#include <bits/stdc++.h>
#define MOD 1000000007
#define MAX 200005
using namespace std;
int N,k; long long a[MAX];
long long r=0;
long long k0(int poc,int t){
    long long rez=0;
    for(int i=poc;i<t+poc;i++)rez+=a[i];
    return rez;
}
void dod(int poc,int t,int k){
    if(k==0){r+=k0(poc,t);}
    else {for(int i=poc;i<t+poc;i++)
            for(int j=i;j<t+poc;j++){dod(i,j+1-i,k-1);}}
}
int main()
{
    ios::sync_with_stdio(0);
    scanf("%d %d",&N,&k);
    for(int i=0;i<N;i++){
        scanf("%lld",&a[i]);
    }
    dod(0,N,k);
    if(r>=MOD)r%=MOD;
    cout<<r;
}